#!/bin/bash

# remove old automated snapshots checking for the "retain=" property

source /etc/environment
source /etc/profile

REGION=$1
RCFILE="$2"

if [ -z "$RCFILE" ]; then
    echo "Usage: $0 <region> <openrc file path>"
    exit 1
fi

source "$RCFILE"
export OS_REGION_NAME=$REGION

openstack volume snapshot list --long --status available -c ID -c Name -c "Created At" -c Properties | grep snap_ | grep retain= | while read line; do 
    snapshotid=$( echo $line | awk '{print $2}' )
    createdat=$( date -d $( openstack volume snapshot show -c "created_at" -f value $snapshotid ) +%s )
    retainvalue=$( openstack volume snapshot show -c "properties" -f value $snapshotid | sed "s/'retain': '\(.*\)'/\1/" | sed "s/[{}]//g" )
    now=$( date +%s )
    if [ "$(( $now - $createdat ))" -gt "$retainvalue" ]; then
        echo "deleting snapshot $line"
        openstack volume snapshot delete $snapshotid
    fi
done

