#!/bin/bash

source /etc/environment
source /etc/profile

SHORTNAME=$1
VOLUME_ID=$2
REGION=$3
RCFILE="$4"
RETAIN=${5:-604800} # 1 week is the default

if [ -z "$REGION" ]; then
    echo "Usage: $0 <short_name> <volume ID> <region> <openrc file path> [<retain seconds>]"
    exit 1
fi

source "$RCFILE"
export OS_REGION_NAME=$REGION

SNAPSHOTNAME=snap_${SHORTNAME}_$(date '+%Y%m%d')
openstack volume snapshot create --force --volume $VOLUME_ID --property retain=${RETAIN} --description "$SHORTNAME automated snapshot $(date)" $SNAPSHOTNAME

